
#include "vs-bb020.h"
#include "memmap.h"
#include <stdio.h>
#include <string.h>

extern void setMtrSpeed(int L , int R);
extern BYTE getMode();
extern unsigned char memmap[MEMMAP_SIZE];

extern double angle;			//px
extern double dangle;			//px
extern double d2angle;			//pxϕ
extern double z_L;				//ړ
extern double dz_L;				//ړx
extern double z_R;				//ړ
extern double dz_R;				//ړx			
extern int enc_L,enc_R;

static double ADave[6];
static int AD_data[6];
static unsigned char calib_mode = CALIB_WHITE;
static int counter;


void main(void)
{
	double Pad_L,Pad_R;
	
//~ĂƂ
	if(getMode() == MODE_STOP || getMode() == MODE_POSE){
	//XCb`ꂽ
		if(getSW()){
		//Cg[X[h甒擾
			if(calib_mode == CALIB_WHITE && (memmap[RUN_MODE]&0x7F) == MODE_LINE_TRACE){
				int j;
				int i;		
				while(getSW());
				for(j = 0;j<6;j++){
					ADave[j] = 0;
				}
				for(i = 0;i< 30;i++){
					for(j = 0;j<6;j++){
						ADave[j] += AdRead(j);
					}
				}
				for(j = 0;j<6;j++){
					ADave[j] /= 30.0;
				}
				BuzzerStart();
				Wait(100);
				BuzzerStop();
				calib_mode = CALIB_GY;
			}
			//ȂWC̃Lu[V
			else{
				while(getSW());
				calibration();				
				counter = 0;
			}
		}
	}
	
//[h̎	
	else if(getMode() == MODE_RUN){
	//Q[pbh̏Ԏ擾
		int temp_PAD;
		static double Old_Pad_R,Old_Pad_L;
		
 		temp_PAD = (int)getPAD(PAD_AN_LY) - 128;
		
	//AiOXeBbN̒lݒ
		Pad_L = -1.0 * (double)(temp_PAD == 128 ? 127 
				: temp_PAD == -128 ? -127 
				: temp_PAD)
			/((double)memmap[PAD_SPEED]/10.0); //4or3or2	
		
		temp_PAD = (int)getPAD(PAD_AN_RX) - 128;
					
		Pad_R = -1.0 * (double)(temp_PAD == 128 ? 127 
				: temp_PAD == -128 ? -127 
				: temp_PAD)
		/((double)memmap[PAD_SPEED]/10.0);
		
	//}ȉ}
		#define dACC 2
		if((Pad_L - Old_Pad_L) > dACC){
			Pad_L = Old_Pad_L + dACC;
		}
		else if((Pad_L - Old_Pad_L) < -dACC){
			Pad_L = Old_Pad_L - dACC;
		}
		if((Pad_R - Old_Pad_R) > dACC){			
			Pad_R = Old_Pad_R + dACC;
		}
		else if((Pad_R - Old_Pad_R) < -dACC){			
			Pad_R = Old_Pad_R - dACC;
		}
		Old_Pad_R = Pad_R;
		Old_Pad_L = Pad_L;
		
	//pbhɂ郂[hύX
		if((getPAD(PAD_B1)&0x01) && (getPAD(PAD_B2)&0x20) && memmap[RUN_MODE] != MODE_LINE_TRACE){
			memmap[RUN_MODE] = MODE_LINE_TRACE;	
			counter = 0;
		}
		else if((getPAD(PAD_B1)&0x01) && getPAD(PAD_B2)&0x40 && memmap[RUN_MODE] != MODE_CONTROL){
			memmap[RUN_MODE] = MODE_CONTROL;		
			counter = 0;
		}

	//[hɂe
		//pbh
		if((memmap[RUN_MODE]&0x7F) == MODE_CONTROL){
			setMtrSpeed((int)(Pad_L + Pad_R),(int)(Pad_L - Pad_R)); 
		}

		//Cg[X
		else if((memmap[RUN_MODE]&0x7F) == MODE_LINE_TRACE){
				int j;
				int i;
				int Right = 0,Left = 0;
				int sum = 0;
				static int sens_buff[2][6];
				
				for(j = 0;j<6;j++){
					AD_data[j] = 0;
				}
				for(i = 0;i< 2;i++){
					for(j = 0;j<6;j++){
							AD_data[j] += AdRead(j);
					}
				}
				for(j = 0;j<6;j++){
					sum += (AD_data[j]/2 - (int)ADave[j]);
				}
						
				for(j = 0;j<6;j++){
					sens_buff[1][j] = sens_buff[0][j];
					
					AD_data[j] /= 2.0;
					sens_buff[0][j] = AD_data[j] - (int)ADave[j] - (sum/6) ;
					if(sens_buff[0][j] <0)
						sens_buff[0][j] = 0;
					sens_buff[0][j] /= 15;
					if(sens_buff[0][j] < 4)
						sens_buff[0][j] = 0;
				}
				
				Left =	  ((double)memmap[LINE_GAIN_PA]/10.0) * (sens_buff[0][0] - sens_buff[0][3])
						+ ((double)memmap[LINE_GAIN_PB]/10.0) * (sens_buff[0][1] - sens_buff[0][4])
						+ ((double)memmap[LINE_GAIN_PC]/10.0) * (sens_buff[0][2] - sens_buff[0][5]);
				
				Left +=   ((double)memmap[LINE_GAIN_PA]/10.0) * (sens_buff[0][0] - sens_buff[1][0] - sens_buff[0][3] + sens_buff[1][3])
						+ ((double)memmap[LINE_GAIN_PB]/10.0) * (sens_buff[0][1] - sens_buff[1][1] - sens_buff[0][4] + sens_buff[1][4])
						+ ((double)memmap[LINE_GAIN_PC]/10.0) * (sens_buff[0][2] - sens_buff[1][2] - sens_buff[0][5] + sens_buff[1][5]);
				
				
				Right = -Left;
				
				if(counter < memmap[LINE_SPEED]){	//͂߂̓CƐɁB
					counter++;
					Left +=  (int)(Pad_L - Pad_R);
					Right += (int)(Pad_L + Pad_R);
				}
				else if(counter < 3* memmap[LINE_SPEED]){	//Xɉ
					counter++;
					Left += (counter -  memmap[LINE_SPEED])/2 + (int)(Pad_L - Pad_R);
					Right += (counter -  memmap[LINE_SPEED])/2 + (int)(Pad_L + Pad_R);
				}
				else{		//ʏ푖s
					Left +=  memmap[LINE_SPEED] + (int)(Pad_L - Pad_R);
					Right +=  memmap[LINE_SPEED] + (int)(Pad_L + Pad_R);
				}
			setMtrSpeed(Right,Left);
		}
	}
}